<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>Insert User</title>
  </head>
  <body>
    <div class="container jumbotron">
      <div class="text-center mb4">
        <h3 style="margin-bottom: 1rem;">Thêm User</h3>
      </div>

      <div class="row form-group">
        <div class="col-sm-3">
          <label for="">First Name</label>
        </div>
        <div class="col-sm-9">
          <input
            class="form-control"
            type="text"
            id="input-firstname"
            placeholder="Nhập first name..."
          />
        </div>
      </div>

      <div class="row form-group">
        <div class="col-sm-3">
          <label for="">Last Name</label>
        </div>
        <div class="col-sm-9">
          <input
            class="form-control"
            type="text"
            id="input-lastname"
            placeholder="Nhập last name..."
          />
        </div>
      </div>

      <div class="row form-group">
        <div class="col-sm-3">
          <label for="">Subject</label>
        </div>
        <div class="col-sm-9">
          <input
            class="form-control"
            type="text"
            id="input-subject"
            placeholder="Nhập subject..."
          />
        </div>
      </div>

      <div class="row form-group">
        <div class="col-sm-3">
          <label for="">Country</label>
        </div>
        <div class="col-sm-9">
          <select class="form-control" id="select-country">
            <option value="VN">Việt Nam</option>
            <option value="USA">USA</option>
            <option value="AUS">Australia</option>
            <option value="CAN">Canada</option>
          </select>
        </div>
      </div>

      <div class="row form-group">
        <div class="col-sm-3">
          <label for="">Customer type</label>
        </div>
        <div class="col-sm-9">
          <select class="form-control" id="select-customer-type">
            <option value="Standard">Standard</option>
            <option value="Gold">Gold</option>
            <option value="Premium">Premium</option>
          </select>
        </div>
      </div>

      <div class="row form-group">
        <div class="col-sm-3"></div>
        <div class="col-sm-9">
          <button class="btn btn-success w-25" id="btn-insert-user">
            Insert User
          </button>
          <button class="btn btn-success w-25">Hủy bỏ</button>
        </div>
      </div>
    </div>
  </body>
</html>

<script>
  $(document).ready(function () {
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gEFirstName = $("#input-firstname");
    var gELastName = $("#input-lastname");
    var gESubject = $("#input-subject");
    var gECountry = $("#select-country");
    var gECustomerType = $("#select-customer-type");
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm thực thi khi nút Insert User được ấn
    $("#btn-insert-user").on("click", function () {
      //B1: get data
      var vDataObj = getFormData();
      //B2: Validate data
      var vCheck = validateFormData(vDataObj);
      if (vCheck) {
        //B3: process insert user info
        callAjaxApiInsertUser(vDataObj);
      }
    });
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm tải dữ liệu gửi về lên các trường trên form
    function loadDataOnForm(paramRes) {
      $("#input-firstname").val(paramRes.firstname);
      $("#input-lastname").val(paramRes.lastname);
      $("#input-subject").val(paramRes.subject);
      $("#select-country").val(paramRes.country);
      $("#select-customer-type").val(paramRes.customerType);
    }

    //hàm thu thập dữ liệu
    function getFormData() {
      var vUpdateInfoObj = new Object();

      vUpdateInfoObj.firstname = $.trim(gEFirstName.val());
      vUpdateInfoObj.lastname = $.trim(gELastName.val());
      vUpdateInfoObj.subject = $.trim(gESubject.val());
      vUpdateInfoObj.country = gECountry.val();
      vUpdateInfoObj.customerType = gECustomerType.val();

      return vUpdateInfoObj;
    }

    //hàm kiểm tra dữ liệu
    function validateFormData(paramObjUserData) {
      if (paramObjUserData.firstname == "") {
        alert("Bạn cần điền first name");
        return false;
      }

      if (paramObjUserData.lastname == "") {
        alert("Bạn cần điền last name");
        return false;
      }

      if (paramObjUserData.subject == "") {
        alert("Bạn cần điền subject");
        return false;
      }

      return true;
    }

    //hàm gọi api để thêm user
    function callAjaxApiInsertUser(paramObjUserData) {
      var vJsonString = JSON.stringify(paramObjUserData);
      $.ajax({
        url: "http://203.171.20.210:8080/crud-api/users/",
        method: "POST",
        contentType: "application/json;charset=UTF-8",
        data: vJsonString,
        success: function (paramResponse) {
          console.log(paramResponse);
          alert("Thêm user thành công");
          window.location.href = "listUsers.html";
        },
        error: function (ajaxtContext) {
          console.log(ajaxtContext);
        },
      });
    }
  });
</script>
